import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
/**
 * Write a description of class Slider here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Slider extends Actor
{
    private Counter counter;
    private Actor slider;
    private int max;
    private int min;
    private int maxLocation;
    private int mouseOrigin;
    private int selfOrigin;
    /**
     * Act - do whatever the Slider wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        MouseInfo mouse = Greenfoot.getMouseInfo();
        if (mouse==null)return;
        if (mouse.getButton()!=1)return;
        if (Greenfoot.mousePressed(this)) {
            mouseOrigin = mouse.getX();
            selfOrigin = getX();
        }
        if (Greenfoot.mouseDragged(this)) {
            changeLocation(selfOrigin+(mouse.getX()-mouseOrigin));
        }
    }  
    
    public Slider(String name, int min, int max, int current)
    {
        this.min = min;
        this.max = max;
        counter = new Counter(name+": ");
        counter.setValue(current);
        GreenfootImage image = new GreenfootImage(14, 14);
        image.setColor(Color.blue);
        image.fillOval(0,0,image.getWidth(),image.getHeight());
        setImage(image);
        slider = new EmptyActor();
        image = new GreenfootImage(80, 6);
        image.setColor(Color.gray);
        image.fillRect(0, 0, image.getWidth(), image.getHeight());
        slider.setImage(image);
    }
    
    public void addedToWorld(World world)
    {
        int w = getSliderImage().getWidth();
        changeLocation((int)((double)(maxLocation*max-maxLocation*min-max*w+getValue()*w)/(double)(max-min)));
    }
    
    public void setLocation(int x, int y)
    {
        super.setLocation(x, y);
        getWorld().addObject(counter, x, y-30);
        getWorld().addObject(slider, x, y);
        maxLocation = x+getSliderImage().getWidth()/2;
    }
    
    public void changeLocation(int x)
    {
        int w = getSliderImage().getWidth();
        if (x < maxLocation-w) x=maxLocation-w;
        if (x > maxLocation) x=maxLocation;
        super.setLocation(x, getY());
        double ratio = (double)(w+x-maxLocation)/(double)w;
        counter.setValue((int)((double)(max-min)*ratio+min));
        action();
    }
    
    public int getValue()
    {
        return counter.getValue();
    }
    
    public GreenfootImage getSliderImage()
    {
        return slider.getImage();
    }
    
    public void action()
    {
        
    }
}
